﻿Type=Class
Version=2.5
@EndOfDesignText@
'Class module
Sub Class_Globals
    Public innerView As View
    Private dragPanel As Panel
    Private downX, downY As Int
    Private ACTION_DOWN, ACTION_MOVE, ACTION_UP As Int
	 Private cbDown, cbMove, cbUp As String
End Sub

Sub Initialize(Activity As Activity, v As View, cbDownArg As String, cbMoveArg As String, cbUpArg As String)
    innerView = v
    dragPanel.Initialize("")
    dragPanel.Color = Colors.Transparent
    Activity.AddView(dragPanel, v.Left, v.Top, v.Width, v.Height)
    ACTION_DOWN = Activity.ACTION_DOWN
    ACTION_MOVE = Activity.ACTION_MOVE
    ACTION_UP = Activity.ACTION_UP
	 cbDown = cbDownArg
	 cbMove = cbMoveArg
	 cbUp = cbUpArg
    Dim r As Reflector
    r.Target = dragPanel
    r.SetOnTouchListener("dragPanel_Touch") 'why reflection instead of the regular Panel_Touch event? Good question which deserves a forum thread of its own (not related to classes)...
End Sub

Private Sub dragPanel_Touch(o As Object, ACTION As Int, x As Float, y As Float, motion As Object) As Boolean
	If ACTION = ACTION_DOWN Then
		downX = x
		downY = y
		If cbDown <> "" Then
			CallSub2(Main, cbDown, Me)
		End If
	Else If ACTION = ACTION_MOVE Then
		innerView.Left = innerView.Left + x - downX
		innerView.Top = innerView.Top + y - downY        
		dragPanel.Left = innerView.Left
		dragPanel.Top = innerView.Top
		If cbMove <> "" Then
			CallSub2(Main, cbMove, Me)
		End If
	Else If ACTION = ACTION_UP Then
		innerView.Left = innerView.Left + x - downX
		innerView.Top = innerView.Top + y - downY        
		dragPanel.Left = innerView.Left
		dragPanel.Top = innerView.Top
		If cbUp <> "" Then
			CallSub2(Main, cbUp, Me)
		End If
	End If
   Return True
End Sub